var defaults, fillDefaults, fs, path;
fs = require('fs');
path = require('path');
defaults = {
  browser: {
    enabled: true,
    include: void 0,
    paths: null,
    prefix: '',
    rootModule: null
  },
  copyrightFrom: (new Date).getFullYear(),
  license: '',
  hooks: {
    begin: null,
    tokenize: null,
    parse: null,
    compile: null,
    write: null,
    end: null,
    bundle: null
  },
  paths: null
};
fillDefaults = function(obj, defaults) {
  var key, result, value;
  result = {};
  for (key in defaults) {
    value = defaults[key];
    result[key] = obj[key] != null ? (typeof obj[key] === 'object') && (typeof value === 'object') ? fillDefaults(obj[key], value) : obj[key] : value;
  }
  return result;
};
module.exports = function() {
  var copyright, currentYear, file, hook, info, json, key, license, module, overrides, package, paths, pth, value, _, _base, _base2, _i, _len, _ref, _ref2, _ref3, _ref4, _ref5;
  try {
    json = fs.readFileSync('beans.json');
  } catch (e) {
    json = '{}';
  }
  overrides = JSON.parse(json);
  info = fillDefaults(overrides, defaults);
  info.hookFns = {};
  _ref = info.hooks;
  for (hook in _ref) {
    module = _ref[hook];
    if (module != null) {
      info.hooks[hook] = file = path.resolve(module);
      info.hookFns[hook] = require(file);
    }
  }
  if (overrides.paths == null) {
    overrides.paths = {
      src: 'lib'
    };
  }
  paths = {};
  _ref2 = overrides.paths;
  for (key in _ref2) {
    value = _ref2[key];
    paths[path.resolve(key)] = path.resolve(value);
  }
  info.paths = paths;
  if ((_ref3 = (_base = info.browser).paths) == null) {
    _base.paths = (function() {
      var _ref4, _results;
      _ref4 = info.paths;
      _results = [];
      for (_ in _ref4) {
        pth = _ref4[_];
        _results.push(pth);
      }
      return _results;
    })();
  }
  package = JSON.parse(fs.readFileSync('package.json'));
  _ref4 = ['author', 'name', 'description', 'version'];
  for (_i = 0, _len = _ref4.length; _i < _len; _i++) {
    key = _ref4[_i];
    if (package[key] == null) {
      throw new Error("Section \"" + key + "\" required in package.json.");
    }
    info[key] = package[key];
  }
  if ((_ref5 = (_base2 = info.browser).rootModule) == null) {
    _base2.rootModule = info.name;
  }
  info.browser.name = info.browser.prefix + info.name;
  currentYear = (new Date).getFullYear();
  if (currentYear > info.copyrightFrom) {
    copyright = info.copyrightFrom + '-' + currentYear;
  } else {
    copyright = currentYear;
  }
  if (info.license !== '') {
    license = "Released under the " + info.license;
  } else {
    license = 'Contact author for licensing information';
  }
  info.headerComment = "/**\n * " + info.browser.name + " " + info.version + " (browser bundle)\n * " + info.description + "\n *\n * Copyright (c) " + copyright + " " + info.author + "\n * " + license + "\n */\n";
  info.header = "this['" + info.name + "'] = (function(){";
  info.footer = "var module = this.require('" + info.browser.rootModule + "');\nmodule.version = '" + info.version + "';\nreturn module; }).call({});";
  return info;
};